# To change this template, choose Tools | Templates
# and open the template in the editor.

__author__="carlota"
__date__ ="$08-mar-2011 15:05:45$"

import urllib2
import nn
from BeautifulSoup import *
from urlparse import urljoin
from pysqlite2 import dbapi2 as sqlite
from html import HTML

mynet=nn.searchnet('nn.db')
# Create a list of words to ignore
ignorewords=set(['the','of','to','and','a','in','is','it'])
class crawler:
  # Initialize the crawler with the name of database
  def __init__(self,dbname):
    #print('en init')
    self.con=sqlite.connect(dbname)

  def _del__(self):
    self.con.close()

  def dbcommit(self):
    self.con.commit()

  # Auxiliary function for getting an entry id and adding
  # it if its not present

  def getentryid(self,table,field,value,createnew=True):
    cur=self.con.execute(
    "select rowid from %s where %s='%s'" % (table,field,value))
    res=cur.fetchone()
    if res==None:
      cur=self.con.execute(
      "insert into %s (%s) values ('%s')" % (table,field,value))
      return cur.lastrowid
    else:
      return res[0]


    return None

  # Index an individual page
  def addtoindex(self,url,soup):


    if self.isindexed(url): return
    print 'Indexing  %s' % url

    # Get the individual words
    text=self.gettextonly(soup)
    words=self.separatewords(text)
    
    # Get the URL id
    urlid=self.getentryid('urllist','url',url)
    
    #Link each word to this url
    for i in range(len(words)):
      word=words[i]
      if word in ignorewords: continue
      wordid=self.getentryid('wordlist','word',word)
      self.con.execute("insert into wordlocation(urlid,wordid,location) \
        values (%d,%d,%d)" % (urlid,wordid,i))

  # Extract the text from a HTML page (no tags)
  def gettextonly(self,soup):
    return None

  #Saparate the words by any non-whitespace character
  def separatewords(self,text):
    return None

  # Return true if this url is already indexed
  def isindexed(self,url):
    u=self.con.execute \
      ("select rowid from urllist where url='%s'" % url).fetchone()
    if u!=None:
     # Check if it has actually been crawled
     v=self.con.execute(
     'select * from wordlocation where urlid=%d' % u[0]).fetchone()
     if v!=None: return True
    return False

  # Add a link between two pages
  def addlinkref(self,urlFrom,urlTo,linkText):
    print("addlinkref 1")
    pass

  # Starting with a list of pages, do a breadth
  # first search to the given depth, indexing pages
  # as we go
  def crawl(self,pages,depth=2):
    pass
    # Create the database tables
  def createindextables(self):
    pass

  def crawl(self,pages,depth=2):
    for i in range(depth):
      newpages=set()
      for page in pages:
        try:
          c=urllib2.urlopen(page)
        except:
          print "Could not open %s" % page
          continue
        soup=BeautifulSoup(c.read())
        self.addtoindex(page,soup)

        links=soup('a')
        for link in links:
         if ('href'  in dict(link.attrs)):
          url=urljoin(page,link['href'])
          if url.find("'")!=-1: continue
          url=url.split('#')[0] #remove location portion
          if url[0:4]=='http' and not self.isindexed(url):
            newpages.add(url)
          linkText=self.gettextonly(link)
          self.addlinkref(page,url,linkText)
        self.dbcommit()
      pages = newpages


  def cerrarbd(self):
      self.con.close()


  def createindextables(self):

    #print('en createindextables')

    self.con.execute('create table urllist(url)')
    #self.execute('create table urllist(url)')

    self.con.execute('create table wordlist(word)')
    self.con.execute('create table wordlocation(urlid,wordid,location)')
    self.con.execute('create table link(fromid integer,toid integer)')
    self.con.execute('create table linkwords(wordid,linkid)')
    self.con.execute('create index wordidx on wordlist(word)')
    self.con.execute('create index urlidx on urllist(url)')
    self.con.execute('create index wordurlidx on wordlocation(wordid)')
    self.con.execute('create index urlfromidx on link(fromid)')
    self.dbcommit()


  def dropindextables(self):

    #print('en dropindextables')
    #self.con.execute('create table urllist(url)')

    self.con.execute('drop table urllist')
    #self.execute('create table urllist(url)')

    self.con.execute('drop table wordlist')
    self.con.execute('drop table wordlocation')
    self.con.execute('drop table link')
    self.con.execute('drop table linkwords')
   
    self.dbcommit()


  def gettextonly(self,soup):

    v=soup.string
    if v==None:
      c=soup.contents
      resulttext=''
      for t in c:
        subtext=self.gettextonly(t)
        resulttext+=subtext+'\n'
      return resulttext
    else:
      return v.strip()

  def separatewords(self,text):
    splitter=re.compile('\\W*')
    return [s.lower() for s in splitter.split(text) if s!='']

  def addlinkref(self,urlFrom,urlTo,linkText):
    words=self.separatewords(linkText)
    fromid=self.getentryid('urllist','url',urlFrom)
    toid=self.getentryid('urllist','url',urlTo)
    if fromid==toid: return
    cur=self.con.execute("insert into link(fromid,toid) values (%d,%d)" %
     (fromid,toid))
    linkid=cur.lastrowid
    for word in words:
     if word in ignorewords: continue
     wordid=self.getentryid('wordlist','word',word)
     self.con.execute("insert into linkwords(linkid,wordid) values (%d,%d)" %
       (linkid,wordid))

  def calculatepagerank(self,iterations=20):
    # clear out the current PageRank tables
    self.con.execute('drop table if exists pagerank')
    self.con.execute('create table pagerank(urlid primary key,score)')

    # initialize every url with a PageRank of 1

    self.con.execute('insert into pagerank select rowid, 1.0 from urllist')
    self.dbcommit()


    for i in range(iterations):
      print "Iteration %d" % (i)
      for (urlid,) in self.con.execute('select rowid from urllist'):
        pr=0.15

      # Loop through all the pages that link to this one
      for (linker,) in self.con.execute(
      'select distinct fromid from link where toid=%d' % urlid):
        # Get the PageRank of the linker
        linkingpr=self.con.execute(
        'select score from pagerank where urlid=%d' % linker).fetchone()[0]

        # Get the total number of links from the linker
        linkingcount=self.con.execute(
        'select count(*) from link where fromid=%d' % linker).fetchone()[0]
        pr+=0.85*(linkingpr/linkingcount)
      self.con.execute(
      'update pagerank set score=%f where urlid=%d' % (pr,urlid))
    self.dbcommit()

class searcher:

  def __init__(self,dbname):
    #print('searcher init ')
    self.con=sqlite.connect(dbname)

  def __del__(self):
    self.con.close()


  def getmatchrows(self,q):
    # Strings to build the query
    #print('getmatchrows q')
    print(q)
    fieldlist='w0.urlid'
    tablelist=''
    clauselist=''
    wordids=[]

    #Split the words by spaces
    words=q.split(' ')
    tablenumber=0

    for word in words:
      # Get the word ID
      #print('dentro de bucle for')
      wordrow=self.con.execute(
        "select rowid from wordlist where word='%s'" % word).fetchone()
      if wordrow!=None:

       #print('dentro de if wordrow ')
       
       wordid=wordrow[0]
       wordids.append(wordid)
       if tablenumber>0:
         #print('if tablenumber>0')
         tablelist+=','
         clauselist+=' and '
         clauselist+='w%d.urlid=w%d.urlid and ' % (tablenumber-1,tablenumber)
       fieldlist+=',w%d.location' % tablenumber
       tablelist+='wordlocation w%d' % tablenumber
       clauselist+='w%d.wordid=%d' % (tablenumber,wordid)
       tablenumber+=1


    #print('fieldlist '+fieldlist)
    #print('tablelist '+tablelist)
    #print('clauselist '+clauselist)

    # Create the query  from the separate parts
    fullquery='select %s from %s where %s' % (fieldlist,tablelist,clauselist)
    print(fullquery)
    cur=self.con.execute(fullquery)

    rows=[row for row in cur]

    h = HTML()
    i=0

    #print('antes de bucle html')


    for e in rows:
     #print('dentro de bucle')
     p  = h.p('text \n')
     e1 = rows[i]
     #e1=float(e1)
     #print(scores[i])
     #print(e1)
     #text = '%s: %-.4f' % ('topMatches e1  ', scores[i])
     #print(text)
     #print('visualizando')
     p.text(rows[i],escape = False)
     i=i+1
     #print('fin visualizar ')
     #p.text(e1,escape=False)

     #print('despues de bucle html')
     print h

    i=0
    h = HTML()

    #print('antes de bucle wordids')
    for e in wordids:
     #print('dentro de bucle wordids ')
     p  = h.p('text \n')
     e1 = wordids[i]
     #e1=float(e1)
     #print(scores[i])
     #print(e1)
     #text = '%s: %-.4f' % ('topMatches e1  ', scores[i])
     #print(text)
     #print('visualizando')
     p.text(wordids[i],escape = False)
     i=i+1
     #print('fin visualizar ')
     #p.text(e1,escape=False)


    #print('despues de bucle html wordids')
    print h

    return rows,wordids

  def getscoredlist(self,rows,wordids):

    #print('getscoredlist rows ')
    #print(rows)
    totalscores=dict([(row[0],0) for row in rows])

    #This is where you'll later put the scoring functions

    weights=[(1.0,self.locationscore(rows)),
             (1.0,self.frequencyscore(rows)),
             (1.0,self.pagerankscore(rows)),
             (1.0,self.linktextscore(rows,wordids))]

    #print('getscoredlist despues de weights ')

    for (weight,scores) in weights:
      for url in totalscores:
        totalscores[url]+=weight*scores[url]
    return totalscores

  def geturlname(self,id):

    return self.con.execute(
    "select url from urllist where rowid=%d" % id).fetchone()[0]

  def query(self,q):

    #print('antes de getmatchrows')
    rows,wordids=self.getmatchrows(q)
    #print('query despues getmatchrows')
    scores=self.getscoredlist(rows,wordids)
    #print('query despues getscoredlist')
    rankedscores=sorted([(score,url) for (url,score) in scores.items()],reverse=1)
    for (score,urlid) in rankedscores[0:10]:
      print '%f\t%s' % (score,self.geturlname(urlid))

    i=0
    h = HTML()

    for (e,f) in rankedscores[0:10]:
     #print('dentro de bucle rankedscores ')
     p  = h.p('text \n')
     p.text(e,escape = False)
     #p.text(f,escape = False)
     p.text(' ')
     p.text(self.geturlname(f),escape = False)
     i=i+1
     #p.text(e1,escape=False)


    #print('despues de bucle html rankedscores')
    print h
    print('wordids')
    print wordids
    return wordids,[r[1] for r in rankedscores[0:10]]



  def normalizescores(self,scores,smallIsBetter=0):
    vsmall=0.00001 #Avoid division by zero errors
    if smallIsBetter:
      minscore=min(scores.values())
      return dict([(u,float(minscore)/max(vsmall,1)) for (u,l) \
        in scores.items()])
    else:
      maxscore=max(scores.values())
      if maxscore==0: maxscore=vsmall
      return dict([(u,float(c)/maxscore) for (u,c) in scores.items()])

  def frequencyscore(self,rows):

    #print('principio de frequencyscore')
    counts=dict([(row[0],0) for row in rows])
    for row in rows: counts[row[0]]+=1
    #print('final de frequencyscore')
    return self.normalizescores(counts)

  def locationscore(self,rows):
    #print('principio locationscore')
    locations=dict([(row[0],1000000) for row in rows])
    for row in rows:
      loc=sum(row[1:])
      if loc<locations[row[0]]: locations[row[0]]=loc
    #print('final locationscore')
    return self.normalizescores(locations,smallIsBetter=1)

  def distancescore(self,rows):
    # If there s only one word, everyone wins

    if len(row[0])<=2: return dict([(row[0],1.0) for row in rows])

    #Initialize the dictionary with large values

    mindistance=dict([(row[0],1000000) for row in rows])

    for row in rows:
      dist=sum([abs(row[i]-row[i-1]) for i in range(2,len(row))])
      if dist<mindistance[row[0]]: mindistance[row[0]]=dist
    return self.normalizescores(mindistance,smallIsBetter=1)

  def inboundlinkscore(self,rows):
    uniqueurls=set([row[0] for row in rows])
    inboundcount=dict([(u,self.con.execute( \
      'select count(*) from link where toid=%d' % u).fetchone()[0]) \
        for u in uniqueurs])
    return self.normalizescores(inboundcount)

  def pagerankscore(self,rows):
     #print('principio de pagerankscore')
     pageranks=dict([(row[0],self.con.execute( \
     'select score from pagerank where urlid=%d' % row[0]).fetchone()[0]) for row in rows])
     maxrank=max(pageranks.values())
     normalizedscores=dict([(u,float(1)/maxrank) for (u,l) in pageranks.items()])
     #print('final de pagerankscore')
     return normalizedscores

  

  def linktextscore(self,rows,wordids):
    linkscores=dict([(row[0],0) for row in rows])
    for wordid in wordids:
      cur=self.con.execute( \
      'select link.fromid,link.toid from linkwords,link where \
      wordid=%d and linkwords.linkid=link.rowid' % wordid)

      for (fromid,toid) in cur:
        if toid in linkscores:
          pr=self.con.execute('select score from pagerank where urlid=%d' % fromid).fetchone()[0]
          linkscores[toid]+=pr
    maxscore=max(linkscores.values())
    normalizedscores=dict([(u,float(1)/maxscore) for (u,l) in linkscores.items()])
    return normalizedscores

def nnscore(self,rows,wordids):
    # Get unique URL IDs as an ordered list
    urlids=[urlid for urlid in set([row[0] for row in rows])]
    nnres=mynet.getresult(wordids,urlids)
    scores=dict([(urlids[i],nnres[i]) for i in range(len(urlids))])
    return self.normalizescores(scores)